//---------------------------------------------------------------------------

#include    "system.hpp"
#include    "classes.hpp"
#pragma hdrstop

#include "Globals.h"
#include "QueryParserComp.hpp"


//namespace Global {

int Global::Keys[MaxKeys];
vector3 Global::pCameraPosition;
vector3 Global::pFreeCameraInit;
int Global::iWindowWidth= 800;
int Global::iWindowHeight= 600;
int Global::iBpp= 16;
bool Global::bFullScreen= true;
bool Global::bFreeFly= false;
bool Global::bWireFrame= false;
bool Global::bSoundEnabled= true;
bool Global::bWriteLogEnabled= true;
double Global::fFogStart= 1000;
double Global::fFogEnd= 2000;
TGround *Global::pGround= NULL;
char Global::szSceneryFile[256]= "scenery//scene.scn";
AnsiString Global::asHumanCtrlVehicle= "EU07-424";

bool __fastcall Global::LoadIniFile(AnsiString asFileName)
{
    TFileStream *fs;
    fs= new TFileStream(asFileName , fmOpenRead	| fmShareCompat	);
    AnsiString str= "";
    int size= fs->Size;
    str.SetLength(size);
    fs->Read(str.c_str(),size);
    str+= "";
    delete fs;
    TQueryParserComp *Parser;
    Parser= new TQueryParserComp(NULL);
    Parser->TextToParse= str;
//    Parser->LoadStringToParse(asFile);
    Parser->First();

    while (!Parser->EndOfFile)
    {
        str= Parser->GetNextSymbol().LowerCase();
        if (str==AnsiString("sceneryfile"))
         {
           str= Parser->GetNextSymbol().LowerCase();
           strcpy(szSceneryFile,str.c_str());
         }
        else
        if (str==AnsiString("humanctrlvehicle"))
         {
           str= Parser->GetNextSymbol().LowerCase();
           asHumanCtrlVehicle= str;
         }
        else
        if (str==AnsiString("width"))
            iWindowWidth= Parser->GetNextSymbol().ToInt();
        else
        if (str==AnsiString("height"))
            iWindowHeight= Parser->GetNextSymbol().ToInt();
        else
        if (str==AnsiString("bpp"))
            iBpp= ((Parser->GetNextSymbol().LowerCase()==AnsiString("32")) ? 32 : 16 );
        else
        if (str==AnsiString("fullscreen"))
            bFullScreen= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
        else
        if (str==AnsiString("freefly")) //Mczapkie-130302
         {
           bFreeFly= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
           pFreeCameraInit.x= Parser->GetNextSymbol().ToDouble();
           pFreeCameraInit.y= Parser->GetNextSymbol().ToDouble();
           pFreeCameraInit.z= Parser->GetNextSymbol().ToDouble();
         }
        else
        if (str==AnsiString("wireframe"))
            bWireFrame= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
// McZapkie! - DebugModeFlag uzywana w mover.pas, warto tez blokowac cheaty gdy false
        else
        if (str==AnsiString("debugmode"))
            DebugModeFlag= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
        else
//McZapkie-040302 - blokada dzwieku - przyda sie do debugowania oraz na komp. bez karty dzw.
        if (str==AnsiString("soundenabled"))
            bSoundEnabled= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
        else
//McZapkie-030402 - logowanie parametrow fizycznych dla kazdego pojazdu z maszynista
        if (str==AnsiString("physicslog"))
            WriteLogFlag= (Parser->GetNextSymbol().LowerCase()==AnsiString("yes"));
        else
//McZapkie-300402 - wylaczanie log.txt
        if (str==AnsiString("debuglog"))
         {
          str=Parser->GetNextSymbol();
          bWriteLogEnabled= (str.LowerCase()==AnsiString("yes"));
         }
    }

}

bool __fastcall Global::InitKeys(AnsiString asFileName)
{
    if (FileExists(asFileName))
    {
        TQueryParserComp *Parser;
        Parser= new TQueryParserComp(NULL);
        Parser->LoadStringToParse(asFileName);

        Keys[k_IncMainCtrl]= Parser->GetNextSymbol().ToInt();
        Keys[k_DecMainCtrl]= Parser->GetNextSymbol().ToInt();
        Keys[k_IncScndCtrl]= Parser->GetNextSymbol().ToInt();
        Keys[k_DecScndCtrl]= Parser->GetNextSymbol().ToInt();
        Keys[k_IncLocalBrakeLevel]= Parser->GetNextSymbol().ToInt();
        Keys[k_DecLocalBrakeLevel]= Parser->GetNextSymbol().ToInt();
        Keys[k_IncBrakeLevel]= Parser->GetNextSymbol().ToInt();
        Keys[k_DecBrakeLevel]= Parser->GetNextSymbol().ToInt();
        Keys[k_Czuwak]= Parser->GetNextSymbol().ToInt();
        Keys[k_Horn]= Parser->GetNextSymbol().ToInt();
//        Keys[k_Horn2]= Parser->GetNextSymbol().ToInt();
        Keys[k_Main]= Parser->GetNextSymbol().ToInt();
        Keys[k_Fuse]= Parser->GetNextSymbol().ToInt();
        Keys[k_Releaser]= Parser->GetNextSymbol().ToInt();
        Keys[k_AntySlipping]= Parser->GetNextSymbol().ToInt();
        Keys[k_Sand]= Parser->GetNextSymbol().ToInt();

        Keys[k_EmergencyBrake]= Parser->GetNextSymbol().ToInt();
        Keys[k_Brake3]= Parser->GetNextSymbol().ToInt();
        Keys[k_Brake2]= Parser->GetNextSymbol().ToInt();
        Keys[k_Brake1]= Parser->GetNextSymbol().ToInt();
        Keys[k_ReleaseBrake]= Parser->GetNextSymbol().ToInt();
        Keys[k_WaveBrake]= Parser->GetNextSymbol().ToInt();

        Keys[k_MechUp]= Parser->GetNextSymbol().ToInt();
        Keys[k_MechDown]= Parser->GetNextSymbol().ToInt();
        Keys[k_MechLeft]= Parser->GetNextSymbol().ToInt();
        Keys[k_MechRight]= Parser->GetNextSymbol().ToInt();
        Keys[k_MechForward]= Parser->GetNextSymbol().ToInt();
        Keys[k_MechBackward]= Parser->GetNextSymbol().ToInt();

        Keys[k_CabForward]= Parser->GetNextSymbol().ToInt();
        Keys[k_CabBackward]= Parser->GetNextSymbol().ToInt();

        Keys[k_Couple]= Parser->GetNextSymbol().ToInt();
        Keys[k_DeCouple]= Parser->GetNextSymbol().ToInt();

        Keys[k_ProgramQuit]= Parser->GetNextSymbol().ToInt();
        Keys[k_ProgramPause]= Parser->GetNextSymbol().ToInt();
        Keys[k_ProgramHelp]= Parser->GetNextSymbol().ToInt();

        Keys[k_DirectionForward]= Parser->GetNextSymbol().ToInt();
        Keys[k_DirectionBackward]= Parser->GetNextSymbol().ToInt();
        Keys[k_BrakeProfile]= Parser->GetNextSymbol().ToInt();
        Keys[k_MaxCurrent]= Parser->GetNextSymbol().ToInt();
        Keys[k_CurrentAutoRelay]= Parser->GetNextSymbol().ToInt();
        Keys[k_Compressor]= Parser->GetNextSymbol().ToInt();
        Keys[k_Converter]= Parser->GetNextSymbol().ToInt();


        delete Parser;

    }
    else
    {
        Keys[k_IncMainCtrl]= VK_ADD;
        Keys[k_DecMainCtrl]= VK_SUBTRACT;
        Keys[k_IncScndCtrl]= VK_DIVIDE;
        Keys[k_DecScndCtrl]= VK_MULTIPLY;
        Keys[k_IncLocalBrakeLevel]= VK_NUMPAD7;
        Keys[k_DecLocalBrakeLevel]= VK_NUMPAD1;
        Keys[k_IncBrakeLevel]= VK_NUMPAD9;
        Keys[k_DecBrakeLevel]= VK_NUMPAD3;
        Keys[k_Czuwak]= VkKeyScan(' ');
        Keys[k_Horn]= VkKeyScan('a');
//        Keys[k_Horn2]= VkKeyScan('z');
        Keys[k_Main]= VkKeyScan('m');  //McZapkie: brakowalo tego, i jeszcze Direction, ale nad tym trzeba sie zastanowic
        Keys[k_Fuse]= VkKeyScan('n');
        Keys[k_Releaser]= VK_CONTROL;
        Keys[k_AntySlipping]= VK_RETURN;
        Keys[k_Sand]= VkKeyScan('s');

        Keys[k_EmergencyBrake]= VK_NUMPAD0;
        Keys[k_Brake3]= VK_NUMPAD8;
        Keys[k_Brake2]= VK_NUMPAD5;
        Keys[k_Brake1]= VK_NUMPAD2;
        Keys[k_ReleaseBrake]= VK_NUMPAD4;
        Keys[k_WaveBrake]= VK_DELETE;

        Keys[k_MechUp]= VK_PRIOR;
        Keys[k_MechDown]= VK_NEXT ;
        Keys[k_MechLeft]= VK_LEFT ;
        Keys[k_MechRight]= VK_RIGHT;
        Keys[k_MechForward]= VK_UP;
        Keys[k_MechBackward]= VK_DOWN;

        Keys[k_CabForward]= VK_HOME;
        Keys[k_CabBackward]= VK_END;

        Keys[k_Couple]= VK_INSERT;
        Keys[k_DeCouple]= VK_DELETE;

        Keys[k_ProgramQuit]= VK_F10;
        Keys[k_ProgramPause]= VK_F3;
        Keys[k_ProgramHelp]= VK_F1;

        Keys[k_DirectionForward]= VkKeyScan('d');
        Keys[k_DirectionBackward]= VkKeyScan('r');
        Keys[k_BrakeProfile]= VkKeyScan('b');
        Keys[k_MaxCurrent]= VkKeyScan('f');
        Keys[k_CurrentAutoRelay]= VkKeyScan('g');
        Keys[k_Compressor]= VkKeyScan('c');
        Keys[k_Converter]= VkKeyScan('x');

    }

}

vector3 __fastcall Global::GetCameraPosition()
{
    return pCameraPosition;
}

void __fastcall Global::SetCameraPosition(vector3 pNewCameraPosition)
{
    pCameraPosition= pNewCameraPosition;
}

//}

//---------------------------------------------------------------------------

#pragma package(smart_init)
