//---------------------------------------------------------------------------

#ifndef GlobalsH
#define GlobalsH

#include "dumb3d.h"
#include "ground.h"
#include "Logs.h"

using namespace Math3D;

const int k_IncMainCtrl= 0;
const int k_DecMainCtrl= 1;
const int k_IncScndCtrl= 2;
const int k_DecScndCtrl= 3;
const int k_IncLocalBrakeLevel= 4;
const int k_DecLocalBrakeLevel= 5;
const int k_IncBrakeLevel= 6;
const int k_DecBrakeLevel= 7;
const int k_Czuwak= 8;
const int k_Horn= 9;
//const int k_Horn2= 10;
const int k_Main= 10;
const int k_Fuse= 11;
const int k_Releaser= 12;
const int k_AntySlipping= 13;
const int k_Sand= 14;

const int k_EmergencyBrake= 15;
const int k_Brake3= 16;
const int k_Brake2= 17;
const int k_Brake1= 18;
const int k_ReleaseBrake= 19;
const int k_WaveBrake= 20;

const int k_MechUp= 21;
const int k_MechDown= 22;
const int k_MechLeft= 23;
const int k_MechRight= 24;
const int k_MechForward= 25;
const int k_MechBackward= 26;

const int k_CabForward= 27;
const int k_CabBackward= 28;

const int k_Couple= 29;
const int k_DeCouple= 30;

const int k_ProgramQuit= 31;
const int k_ProgramPause= 32;
const int k_ProgramHelp= 33;

const int k_DirectionForward= 34;
const int k_DirectionBackward= 35;
const int k_BrakeProfile= 36;
const int k_MaxCurrent= 37;
const int k_CurrentAutoRelay= 38;
const int k_Compressor= 39;
const int k_Converter= 40;

const int MaxKeys= 38;



class Global
{
public:
    static int Keys[MaxKeys];
    static vector3 pCameraPosition;
    static vector3 pFreeCameraInit;
    static int iWindowWidth;
    static int iWindowHeight;
    static int iBpp;
    static bool bFullScreen;
    static bool bFreeFly;
    static bool bWireFrame;
//McZapkie-040302
    static bool bSoundEnabled;
    static double fFogStart;
    static double fFogEnd;
    static TGround *pGround;
    static char szSceneryFile[256];
//McZapkie-170602: zewnetrzna definicja pojazdu uzytkownika    
    static AnsiString asHumanCtrlVehicle;
    static bool __fastcall LoadIniFile(AnsiString asFileName="eu07.ini");
    static bool __fastcall InitKeys(AnsiString asFileName="keys.ini");
    static vector3 __fastcall GetCameraPosition();
    static void __fastcall SetCameraPosition(vector3 pNewCameraPosition);
    static bool bWriteLogEnabled;
};

//---------------------------------------------------------------------------
#endif
